 # -*- coding: utf-8 -*-
from socket import socket, AF_INET, SOCK_STREAM
import time
import cv2 as cv
import numpy as np
#HOST        = '127.0.0.1'
#HOST        = '172.21.2.132'
HOST        = '172.25.10.38'
PORT        = 51000


fn = 'my_pic.jpg'

def find_rect_of_target_color(image):
  hsv = cv.cvtColor(image, cv.COLOR_BGR2HSV_FULL)
  h = hsv[:, :, 0]
  s = hsv[:, :, 1]
  mask = np.zeros(h.shape, dtype=np.uint8)
  mask[((h < 20) | (h > 200)) & (s > 128)] = 255
  contours, _ = cv.findContours(mask, cv.RETR_TREE, cv.CHAIN_APPROX_SIMPLE)
  rects = []
  for contour in contours:
    approx = cv.convexHull(contour)
    rect = cv.boundingRect(approx)
    rects.append(np.array(rect))
  return rects

cap = cv.VideoCapture(0)
#cap.set(cv.CAP_PROP_FOURCC, cv.VideoWriter_fourcc('H', '2', '6', '4'))

	# 解像度の設定
cap.set(cv.CAP_PROP_FRAME_WIDTH, 640)
cap.set(cv.CAP_PROP_FRAME_HEIGHT, 480)
	
	#2値化したときのピクセルの値
DELTA_MAX = 255

	#各ドットの変化を検知するしきい値
DOT_TH = 20

sock = socket(AF_INET, SOCK_STREAM)
sock.connect((HOST, PORT))


while True:

    ret, frame = cap.read()
    cv.imwrite(fn, frame)

    _, frame = cap.read()
    rects = find_rect_of_target_color(frame)
    if len(rects) > 0:
      rect = max(rects, key=(lambda x: x[2] * x[3]))
      cv.rectangle(frame, tuple(rect[0:2]), tuple(rect[0:2] + rect[2:4]), (255, 0, 0), thickness=2)
      print(rect[2])
    if rect[2] < 250 and rect[2] > 60:
      conerect = 1
    else:
      conerect = 0
        # 撮影した写真を読み込む
    #img = cv.imread(fn)
    img = frame

        # 顔検出の処理効率化のために、写真の情報量を落とす（モノクロにする）
    grayimg = cv.cvtColor(img, cv.COLOR_BGR2GRAY)


        # ボール検出のための学習元データを読み込む
    ball_cascade = cv.CascadeClassifier('cascade.xml')
        # ボール検出を行う
    ballrect = ball_cascade.detectMultiScale(grayimg)

        # コーン検出のための学習元データを読み込む
    #cone_cascade = cv.CascadeClassifier('cone_cascade.xml')
        # コーン検出を行う
    #conerect = cone_cascade.detectMultiScale(grayimg)


    print(ballrect)
    print(conerect)

        # ボールを検出した場合
    if len(ballrect) > 0:
            
        for rect in ballrect:# ボールを検出した場所すべてに赤色で枠を描画する
            cv.rectangle(img, tuple(rect[0:2]), tuple(rect[0:2]+rect[2:4]), (0, 0, 255), thickness=3)
        if conerect > 0:# コーンを検出した場合
            try:
                # メッセージ送信 （以下では 0?9までを１秒おきに送信）
                # data を文字列に変換する
                mess = str(4);
                print ('send message: ' + mess)
                # encode で文字列型をデータ型に変換
                sock.send(mess.encode())
                 

            except:
                print ('retry: ')

        else:# コーンを検出してない場合
            try:
                    
                # メッセージ送信 （以下では 0?9までを１秒おきに送信）
                # data を文字列に変換する
                mess = str(1);
                print ('send message: ' + mess)
                # encode で文字列型をデータ型に変換
                sock.send(mess.encode())
                #time.sleep(1)


            except:
                print ('retry: ')


    else:# ボールが無い場合

        if conerect > 0:# コーンを検出した場合
            try:
                # メッセージ送信 （以下では 0?9までを１秒おきに送信）
                # data を文字列に変換する
                mess = str(3);
                print ('send message: ' + mess)
                # encode で文字列型をデータ型に変換
                sock.send(mess.encode())
                 

            except:
                print ('retry: ')

        else:# コーンを検出してない場合
            try:
                    
                # メッセージ送信 （以下では 0?9までを１秒おきに送信）
                # data を文字列に変換する
                mess = str(2);
                print ('send message: ' + mess)
                # encode で文字列型をデータ型に変換
                sock.send(mess.encode())
                #time.sleep(1)


            except:
                print ('retry: ')




        # 結果の画像を表示する
    cv.imshow('camera', img)
        # 結果を書き出す
    cv.imwrite(fn, img)
    # 何かキーが押されるまで待機する
    k = cv.waitKey(10)
    if k == 27:#Esc入力時は終了
        break

print("Bye!\n")
   # 通信の終了
sock.close()
cap.release()
# 表示したウィンドウを閉じる
cv.destroyAllWindows()
